﻿//Advanced Composition Grids
// v1.0 - initial release
// v1.01 - minor fixes
// v1.03 - supports non-square pixels
// v1.03.1 - fixed colors for light UI themes
// v1.04 - true isometric mode (hold Alt key to bring up the old one)
// v1.05 - Interface updated a bit

//Now the code is a little bit messy
//it's getting ready for a major update

//Nik Ska, 2013-2017
//CC-BY-SA

#script "Advanced Composition Grids"

var acGrids = this;
acGrids.scriptTitle = "Advanced Composition Grids";
acGrids.scriptVersion = "1.05";

acGrids.names = {
  layerName: "Modular Grid",
  hex: "Hexagon",
  hexSize: "HEXAGON_size",
  iso: "Isometric",
  isoSize: "ISOMETRY_size",
  isoChck1: "Vertical Lines",
  isoChck2: "Small Isometric",
  diag: "Diagonals",
  cross: "Cross",
  thirds: "Thirds",
  sqGrid: "Square Grid",
  sqSize: "SQUARE_GRID_size",
  sqChck: "Small Squares",
  sqBig: "Big Squares",
  sqSmall: "Small Squares",
  safe: "Safe Margin",
  safeSize: "SAFE_MAGRIN_size",
  golden: "Golder Ratio",
  goldenRect: "Golder Rectangles",
  goldenPos1: "p1",
  goldenPos2: "p2",
  goldenSquares: "Toggle Golden Ratio Rectangles",

  rect1: "Rectangle",
  rect2: "Rectangle 2",
  hex: "Hexagon",
  rep1: "Repeater",
  rep2: "Repeater 2",


  tips: {
    set: "Edit grid presets",
    select: "Select grid",
    about: "About the script",
    draw: "Draw selected lines",
    add: "Add new grid preset",
    rem: "Remove preset",
  },
};


acGrids.grids = {
  "s1":{
    name: "Bunch of Grids",
    content: {
      "drawXLine":{
      },
      "drawThirds":{
      },
      "drawSqGrid":{
      },
      "drawSafeMargins":{
      }
    }
  },
  "s2":{
    name: "Bare Minimum",
    content: [acGrids.drawXLine, acGrids.drawThirds, acGrids.drawSqGrid],
  },
 "s3":{
    name: "Only Thirds",
    content: [acGrids.drawThirds],
  },
  "s4":{
    name: "Hexagons",
    content: [acGrids.drawHexagon],
  },
  "s5":{
    name: "Isometric",
    content: [acGrids.drawIsometry],
  },
  "s6":{
    name: "Golden Ratio",
    content: [acGrids.drawIsometry],
  },
}

acGrids.gridNames = [];
var tmp = 0;

for(var k in acGrids.grids){
  if(acGrids.grids[k].name!="anonymous"){
    acGrids.gridNames[tmp] = acGrids.grids[k].name;
    tmp++;
  }
}

acGrids.setColorPicker = function(thisObj, _panel){
  var colorDropdown = _panel.add("dropdownlist", undefined, ['','','','','','','']);
  colorDropdown.size = [48, 25];
  colorDropdown.selection = 0;

  for(var c = 0; c<8; c++){
    colorDropdown.items[c].image = thisObj.colorFiles[c];
  }

  return colorDropdown
}

acGrids.showSet = function(thisObj){
  this.nameSet = function(_panel, _name){
    var ns = _panel.add("group{orientation:'row',alignment:['left','top']}");
    ns.add("staticText", undefined, "Name:");
    return(ns.add("editText", undefined, _name))
  }

  thisObj.set = new Window("palette", "Settings",undefined, {resizeable:false});
  thisObj.set.alignChildren = ["left", "top"];

  var lineOne = thisObj.set.add("group{orientation:'row',alignment:['left','top']}")

  var myDropdown = lineOne.add ("dropdownlist", undefined, thisObj.gridNames).setTip(thisObj.names.tips.select).setFG([1,1,1]);
  myDropdown.size = [120, 25];
  myDropdown.selection = thisObj.lastSel;

  var addBttn = thisObj.setPushBttn(lineOne, thisObj.iconsFiles[0], thisObj.names.tips.add)
  var remBttn = thisObj.setPushBttn(lineOne, thisObj.iconsFiles[1], thisObj.names.tips.rem)

  addBttn.addEventListener("mouseup", function(k){
    if(k.button == 0){
      this.setState(false);
      //thisObj.showSet(thisObj);
    }
  });

  var setPanel = thisObj.set.add("group{orientation:'column',alignment:['left','top']}");
  setPanel.alignChildren = ['left', 'top'];

  var nameSetEdit = this.nameSet(setPanel, myDropdown.selection);
  nameSetEdit.preferredSize = [120,25];

  myDropdown.onChange = function(){
    nameSetEdit.text = myDropdown.selection;
  }

  //var cPicker1 = thisObj.setColorPicker(thisObj, thisObj.set)

  var bttnHolder = thisObj.set.add("group{orientation:'row',alignment:['left','top']}");
  bttnHolder.size = [160,30];
  var saveBttn = bttnHolder.add("button",undefined, "Save").setFG([1,1,1]);
  saveBttn.preferredSize = [50,25];

  var closeBttn = bttnHolder.add("button",undefined, "Close").setFG([1,1,1]);
  closeBttn.preferredSize = [50,25];




  closeBttn.onClick = function(){
    thisObj.set.close();
  }  

  thisObj.set.center();
  thisObj.set.show();
}

acGrids.buildGUI = function(thisObj){

  thisObj.getPrefs();

  // thisObj.iconsFiles = [];
  // thisObj.colorFiles = [];
  // var fldr = new Folder(Folder.userData.fullName + '/Aescripts/acGrids/');
  // fldr.create();
  // for(var i = 0; i <= thisObj.iconsBinaries.length; i++) {
  //   thisObj.iconsFiles[i] = new File(fldr.fullName+'/acGridsIconFile_'+ i + ".png");
  //   thisObj.iconsFiles[i].encoding = "BINARY";
  //   thisObj.iconsFiles[i].open("w");
  //   thisObj.iconsFiles[i].write(thisObj.iconsBinaries[i]);
  //   thisObj.iconsFiles[i].close();
  // }
  // for(var i = 0; i <= thisObj.colorBinaries.length; i++) {
  //   thisObj.colorFiles[i] = new File(fldr.fullName+'/acGridsColorFile_'+ i + ".png");
  //   thisObj.colorFiles[i].encoding = "BINARY";
  //   thisObj.colorFiles[i].open("w");
  //   thisObj.colorFiles[i].write(thisObj.colorBinaries[i]);
  //   thisObj.colorFiles[i].close();
  // }


	thisObj.w = (thisObj instanceof Panel) ? thisObj : new Window("palette", "Advanced Comp Grids", undefined, {resizeable:true});
  thisObj.w.margins = [10,10,10,10];
	thisObj.w.alignChildren = ['left', 'top'];
  // thisObj.w.setBG([0.25,0.25,0.25]);

  var mainCol = thisObj.w.add("group{orientation: 'column', alignChildren: ['left', 'top']}");

  mainCol.add("group{margins:[5,0,0,0]}").add("staticText", undefined, "Select Grid")
  var myDropdown = mainCol.add("dropdownlist", undefined, thisObj.gridNames).setTip(thisObj.names.tips.select); //.setFG([1,1,1]).setBG([0.25,0.25,0.25]);
  myDropdown.size = [120, 30];
  myDropdown.selection = thisObj.lastSel;

  var buildBttn = mainCol.add("group{orientation:'row',alignment:['center','center'],margins:[5,0,3,0]}").add("button",undefined, "Draw!").setTip(thisObj.names.tips.draw); //.setFG([1,1,1]).setBG([0.25,0.25,0.25]);
  buildBttn.preferredSize = [120,30];

  // var setBttn = thisObj.setPushBttn(lineThree, thisObj.iconsFiles[3], thisObj.names.tips.set);

  // setBttn.addEventListener("mouseup", function(k){
  //   if(k.button == 0){
  //     this.setState(false);
  //     thisObj.showSet(thisObj);
  //   }
  // });

  buildBttn.onClick = function(){
    app.beginUndoGroup("Creating Grid");
    thisObj.lastSel = myDropdown.selection.index;
    thisObj.setPrefs();
    var alt = false;
    if (ScriptUI.environment.keyboardState.altKey){
      alt = true;
    }
    thisObj.makeGridSandwitch(myDropdown.selection.index, myDropdown.selection, alt);
    app.endUndoGroup();
  }

	if (thisObj.w instanceof Window){
    thisObj.w.center();
    thisObj.w.show();
  }
  else thisObj.w.layout.layout(true);
}

acGrids.buildSetGUI = function(thisObj){
  //future function for settings window
}

acGrids.makeGridSandwitch = function(sel, selName, alt){
  //master function, literally creating modular grids sandwitch 

  //alert(sel);
  var activeComp = app.project.activeItem;
  if(activeComp && activeComp instanceof CompItem){

    var shapeLayer = activeComp.layers.addShape();
    shapeLayer.property("ADBE Transform Group").property("ADBE Position").setValue([0,0]);
    shapeLayer.name = selName;
    shapeLayer.guideLayer = true;
    shapeLayer.label = 9+sel;
    var s = app.project.activeItem.width;

    if(sel === 0){
      this.drawXLine(this.names.diag, shapeLayer, true, 2, [1,0,0,1]);
      this.drawXLine(this.names.cross, shapeLayer, false, 2, [0,1,0,1]);
      this.drawThirds(this.names.thirds, shapeLayer, true, true, 2, [0,1,1,1]);
      this.drawSqGrid(this.names.sqGrid, shapeLayer, Math.ceil(s/8), false, 2, [.5,.5,.5,1]);
      this.drawSafeMargins(this.names.safe, shapeLayer, 75,[0.1,1,0,1]);
    }
    else if(sel === 1){
      this.drawXLine(this.names.diag, shapeLayer, true, 2, [1,0,0,1]);
      this.drawXLine(this.names.cross, shapeLayer, false, 2, [0,1,0,1]);
      this.drawThirds(this.names.thirds, shapeLayer, true, true, 2, [0,1,1,1]);
    }
    else if(sel === 2){
      this.drawThirds(this.names.thirds, shapeLayer, true, true, 2, [0,1,1,1]);
    }
    else if(sel === 3){
      this.drawHexagon(this.names.hex, shapeLayer, Math.ceil(s/20), 2, [0,1,1,1]);
    }
    else if(sel === 4){
      this.drawIsometry(this.names.iso, shapeLayer, Math.ceil(s/5), 2, [1,1,1,1], alt);
    }
    else if(sel === 5){
      this.drawGoldenRatio(this.names.golden, shapeLayer, 3, [1,1,1,1]);
    }
    
    shapeLayer.selected = false;
    shapeLayer.moveToBeginning();
  }
  else{
    alert("You have to have an active composition");
    return;
  }
}

acGrids.drawSqGrid = function(gName, masterLayer, size, small, thick, color){
  //draws a rectangle grid of the said size, number of columns and rows

  acGridsService.setSlider(masterLayer, acGrids.names.sqSize, size, acGrids.expr.sliderCheck);
  acGridsService.setChckbx(masterLayer, acGrids.names.sqChck, true, '');

  var activeComp = app.project.activeItem;
  var compSize = [activeComp.width, activeComp.height];

  var cols = Math.floor(compSize[0]/size)+1;
  var rows = Math.floor(compSize[1]/size)+1;

  var contents = masterLayer.property("ADBE Root Vectors Group");
  var g = contents.addProperty("ADBE Vector Group");
  var g1 = g.property("ADBE Vectors Group");

  g.name = gName;

  //-------------
  //Big Squares
  //-------------

  var g = g1.addProperty("ADBE Vector Group");
  var g0 = g.property("ADBE Vectors Group");

  g.name = acGrids.names.sqBig;

  var rect = g0.addProperty("ADBE Vector Shape - Rect");
  rect.name = acGrids.names.rect1;
  rect.property("ADBE Vector Rect Size").expression = acGrids.expr.sqSize;
  
  acGridsService.setRepeater(this.names.rep1, g0, 10, acGrids.expr.sqR1Copies, 0, acGrids.expr.sqR1Offset, [0,100], acGrids.expr.sqR1Pos);
  acGridsService.setRepeater(this.names.rep2, g0, 10, acGrids.expr.sqR2Copies, 0, acGrids.expr.sqR2Offset, [100,0], acGrids.expr.sqR2Pos);

  acGridsService.setStroke(g0, thick, color);

  g.property("ADBE Vector Transform Group").property("ADBE Vector Position").setValue([activeComp.width*activeComp.pixelAspect, activeComp.height]*.5)

  //-------------
  //Small Squares
  //-------------

  var g = g1.addProperty("ADBE Vector Group");
  var g2 = g.property("ADBE Vectors Group");
  g.name = acGrids.names.sqSmall;

  var rect = g2.addProperty("ADBE Vector Shape - Rect");
  rect.property("ADBE Vector Rect Size").expression = acGrids.expr.sqSize2;
  rect.name = acGrids.names.rect2;

  acGridsService.setRepeater(this.names.rep1, g2, 10, acGrids.expr.sqR3Copies, 0, acGrids.expr.sqR3Offset, [0,100], acGrids.expr.sqR3Pos);
  acGridsService.setRepeater(this.names.rep2, g2, 10, acGrids.expr.sqR4Copies, 0, acGrids.expr.sqR4Offset, [100,0], acGrids.expr.sqR4Pos);

  acGridsService.setStroke(g2, thick/2, color);

  g.property("ADBE Vector Transform Group").property("ADBE Vector Position").expression = acGrids.expr.sqSmPos;
  g.property("ADBE Vector Transform Group").property("ADBE Vector Group Opacity").expression = acGrids.expr.sqSmallToggle;
}


acGrids.drawThirds = function(gName, masterLayer, hor, ver, thick, color){
  //making thirds. You may draw only horizontal or vertical ones, by setting hor/ver -> true/false
  var activeComp = app.project.activeItem;
  var size = [activeComp.width, activeComp.height];
  var step = [activeComp.width/3, activeComp.height/3];

  var contents = masterLayer.property("ADBE Root Vectors Group");
  var g = contents.addProperty("ADBE Vector Group");
  var g1 = g.property("ADBE Vectors Group");

  g.name = gName;

  //defining paths

  var h1Path = new Shape();
  h1Path.vertices = [[0,step[1]], [size[0]*activeComp.pixelAspect,step[1]]];
  h1Path.closed = false;
  
  var h2Path = new Shape();
  h2Path.vertices = [[0,step[1]*2], [size[0]*activeComp.pixelAspect,step[1]*2]];
  h2Path.closed = false;
  
  var v1Path = new Shape();
  v1Path.vertices = [[step[0]*activeComp.pixelAspect,0], [step[0]*activeComp.pixelAspect,size[1]]];
  v1Path.closed = false;
  
  var v2Path = new Shape();
  v2Path.vertices = [[step[0]*2*activeComp.pixelAspect,0], [step[0]*2*activeComp.pixelAspect,size[1]]];
  v2Path.closed = false;

  //start adding them

  if(hor === true){
    var h1 = g1.addProperty("ADBE Vector Shape - Group");
    h1.name = "h1";
    h1.property("ADBE Vector Shape").setValue(h1Path);
    
    var h2 = g1.addProperty("ADBE Vector Shape - Group");
    h2.name = "h2";
    h2.property("ADBE Vector Shape").setValue(h2Path);
  }

  if(ver === true){
    var v1 = g1.addProperty("ADBE Vector Shape - Group");
    v1.name = "v1";
    v1.property("ADBE Vector Shape").setValue(v1Path);
  
    var v2 = g1.addProperty("ADBE Vector Shape - Group");
    v2.name = "v2";
    v2.property("ADBE Vector Shape").setValue(v2Path);
  }
  
  acGridsService.setStroke(g1, thick, color);

  //add dots

  var g = g1.addProperty("ADBE Vector Group");
  var g2 = g.property("ADBE Vectors Group");

  g.name = "dots";
  var d = g2.addProperty("ADBE Vector Shape - Ellipse");
  d.property("ADBE Vector Ellipse Size").setValue(Math.ceil(size[0]/150)*[1,1]);
  d.property("ADBE Vector Ellipse Position").setValue([step[0]*activeComp.pixelAspect, step[1]]);

  acGridsService.setRepeater(this.names.rep1, g2, 2, '', 0, '', [step[0]*activeComp.pixelAspect,0], '');
  acGridsService.setRepeater(this.names.rep2, g2, 2, '', 0, '', [0,step[1]], '');

  g2.addProperty("ADBE Vector Graphic - Fill").property("ADBE Vector Fill Color").setValue(color);

 
}

acGrids.drawXLine = function(gName, masterLayer, diag, thick, color){
  var activeComp = app.project.activeItem;
  var size = [activeComp.width, activeComp.height];
  var contents = masterLayer.property("ADBE Root Vectors Group");
  var g = contents.addProperty("ADBE Vector Group");
  var g1 = g.property("ADBE Vectors Group");

  g.name = gName;

  //defining paths

  var l1Path = new Shape();
  l1Path.closed = false;
  
  var l2Path = new Shape();
  l2Path.closed = false;

  if(diag === true){
    l1Path.vertices = [[0,0], [size[0]*activeComp.pixelAspect,size[1]]];
    l2Path.vertices = [[0,size[1]], [size[0]*activeComp.pixelAspect,0]];
  }
  else{
    l1Path.vertices = [[size[0]/2*activeComp.pixelAspect,0], [size[0]/2*activeComp.pixelAspect,size[1]]];
    l2Path.vertices = [[0,size[1]/2], [size[0]*activeComp.pixelAspect,size[1]/2]];
  }

  var l1 = g1.addProperty("ADBE Vector Shape - Group");
  l1.name = "l1";
  l1.property("ADBE Vector Shape").setValue(l1Path);
    
  var l2 = g1.addProperty("ADBE Vector Shape - Group");
  l2.name = "l2";
  l2.property("ADBE Vector Shape").setValue(l2Path);
 
  acGridsService.setStroke(g1, thick, color);
 
}

acGrids.drawIsometry = function(gName, masterLayer, isoSize, thick, color, old){
  var activeComp = app.project.activeItem;
  var size = [activeComp.width, activeComp.height];
  var center = size*0.5;
  var W = size[0]/2;
  var H = size[1]/2;

  //isometric paths
  var l1Path = new Shape();
  var l2Path = new Shape();

  if(!old){
    //shiny new 120 degdees isometry
    var a = Math.tan(Math.PI/6)*W;

    l1Path.vertices = [[0, center[1] + a], [size[0]*activeComp.pixelAspect, center[1] - a]];
    l1Path.closed = false;
    
    l2Path.vertices = [[0, center[1] - a], [size[0]*activeComp.pixelAspect, center[1] + a]]
    l2Path.closed = false;
  }
  else{
    //old-school isometry
    l1Path.vertices = [[0,center[1]-W/2], [size[0]*activeComp.pixelAspect,center[1]+W/2]];
    l1Path.closed = false;
    
    l2Path.vertices = [[0,center[1]+W/2], [size[0]*activeComp.pixelAspect,center[1]-W/2]];
    l2Path.closed = false;
  }

  var l3Path = new Shape();
  l3Path.vertices = [[size[0]/2*activeComp.pixelAspect, 0], [size[0]/2*activeComp.pixelAspect, size[1]]];
  l3Path.closed = false;


  acGridsService.setSlider(masterLayer, acGrids.names.isoSize, isoSize, acGrids.expr.sliderCheck);
  acGridsService.setChckbx(masterLayer, acGrids.names.isoChck1, true, '');
  acGridsService.setChckbx(masterLayer, acGrids.names.isoChck2, true, '');

  //-------------
  //Big Isometric
  //-------------

  var contents = masterLayer.property("ADBE Root Vectors Group");
  var g = contents.addProperty("ADBE Vector Group");
  var g1 = g.property("ADBE Vectors Group");

  g.name = gName;

  var g = g1.addProperty("ADBE Vector Group");
  var g0 = g.property("ADBE Vectors Group");

  g.name = "Isometric Big";

  var l1 = g0.addProperty("ADBE Vector Shape - Group");
  l1.name = "l1";
  l1.property("ADBE Vector Shape").setValue(l1Path);
    
  var l2 = g0.addProperty("ADBE Vector Shape - Group");
  l2.name = "l2";
  l2.property("ADBE Vector Shape").setValue(l2Path);

  acGridsService.setRepeater(this.names.rep1, g0, 10, acGrids.expr.isoR1Copies, 0, acGrids.expr.isoR1Offset, [0,100], acGrids.expr.isoR1Pos);
 
  acGridsService.setStroke(g0, thick, color);

  //---------
  //Verticals
  //---------

  var g = g1.addProperty("ADBE Vector Group");
  var g2 = g.property("ADBE Vectors Group");
  g.name = acGrids.names.isoChck1;

  var l3 = g2.addProperty("ADBE Vector Shape - Group");
  l3.name = "vert";
  l3.property("ADBE Vector Shape").setValue(l3Path);

  if(old) repExpr = acGrids.expr.isoR3Pos;
  else repExpr = acGrids.expr.isoR3PosNew;

  acGridsService.setRepeater(this.names.rep1, g2, 10, acGrids.expr.isoR3Copies, 0, acGrids.expr.isoR3Offset, [100,0], repExpr);

  acGridsService.setStroke(g2, thick, color);

  g.property("ADBE Vector Transform Group").property("ADBE Vector Group Opacity").expression = acGrids.expr.isoVertToggle;

  //----------
  //Small Ones
  //----------

  var g = g1.addProperty("ADBE Vector Group");
  var g3 = g.property("ADBE Vectors Group");
  g.name = acGrids.names.isoChck2;

  var l1 = g3.addProperty("ADBE Vector Shape - Group");
  l1.name = "l1";
  l1.property("ADBE Vector Shape").setValue(l1Path);
    
  var l2 = g3.addProperty("ADBE Vector Shape - Group");
  l2.name = "l2";
  l2.property("ADBE Vector Shape").setValue(l2Path);

  acGridsService.setRepeater(this.names.rep1, g3, 10, acGrids.expr.isoR2Copies, 0, acGrids.expr.isoR2Offset, [0,100], acGrids.expr.isoR2Pos);

  acGridsService.setStroke(g3, thick/2, color);
  g3.property("ADBE Vector Graphic - Stroke").property("ADBE Vector Stroke Dashes").addProperty("ADBE Vector Stroke Dash 1").expression = acGrids.expr.isoDash;
  g.property("ADBE Vector Transform Group").property("ADBE Vector Group Opacity").expression = acGrids.expr.isoSmallToggle;
 
}


acGrids.drawHexagon = function(gName, masterLayer, size, thick, color){
  acGridsService.setSlider(masterLayer, acGrids.names.hexSize, size, acGrids.expr.sliderCheck);
  var activeComp = app.project.activeItem;
  
  var contents = masterLayer.property("ADBE Root Vectors Group");
  var g = contents.addProperty("ADBE Vector Group");
  var g1 = g.property("ADBE Vectors Group");

  g.name = gName;
  var hex = g1.addProperty("ADBE Vector Shape - Star");
  hex.name = acGrids.names.hex;
  hex.property("ADBE Vector Star Type").setValue(2);
  hex.property("ADBE Vector Star Points").setValue(6);
  hex.property("ADBE Vector Star Outer Radius").expression = acGrids.expr.hexSize;

  acGridsService.setRepeater(this.names.rep1, g1, 10, acGrids.expr.hexR1Copies, 0, acGrids.expr.hexR1Offset, [0,100], acGrids.expr.hexR1Pos);
  acGridsService.setRepeater(this.names.rep2, g1, 10, acGrids.expr.hexR2Copies, 0, acGrids.expr.hexR2Offset, [0,100], acGrids.expr.hexR2Pos);

  g.property("ADBE Vector Transform Group").property("ADBE Vector Position").setValue([activeComp.width*activeComp.pixelAspect, activeComp.height]*.5);

  g.property("ADBE Vector Transform Group").property("ADBE Vector Scale").expression = acGrids.expr.aspectCorrect;
  

  acGridsService.setStroke(g1, thick, color);

}

acGrids.drawSafeMargins = function(gName, masterLayer, percentage, color){
  //draws safe margin for a given percentage of area
  acGridsService.setSlider(masterLayer, acGrids.names.safeSize, percentage, acGrids.expr.safeSlider);
  var activeComp = app.project.activeItem;
  var compSize = [activeComp.width, activeComp.height];
  var contents = masterLayer.property("ADBE Root Vectors Group");
  var g = contents.addProperty("ADBE Vector Group");
  var g1 = g.property("ADBE Vectors Group");

  g.name = gName;

  var rect = g1.addProperty("ADBE Vector Shape - Rect");
  rect.name = acGrids.names.rect1;
  rect.property("ADBE Vector Rect Size").setValue([compSize[0]*activeComp.pixelAspect, compSize[1]]);
  rect.property("ADBE Vector Rect Position").setValue([compSize[0]*activeComp.pixelAspect, compSize[1]]/2);

  var rect2 = g1.addProperty("ADBE Vector Shape - Rect");
  rect2.name = acGrids.names.rect1;
  rect2.property("ADBE Vector Rect Size").setValue([compSize[0]*activeComp.pixelAspect, compSize[1]]);
  rect2.property("ADBE Vector Rect Size").expression = acGrids.expr.safeRect2;
  rect2.property("ADBE Vector Rect Position").setValue([compSize[0]*activeComp.pixelAspect, compSize[1]]/2);

  g1.addProperty("ADBE Vector Filter - Merge").property("ADBE Vector Merge Type").setValue(3);

  var f = g1.addProperty("ADBE Vector Graphic - Fill");
  f.property("ADBE Vector Fill Color").setValue(color);
  f.property("ADBE Vector Fill Opacity").setValue(20);
}

acGrids.drawGoldenRatio = function(gName, masterLayer, thick, color){
  var activeComp = app.project.activeItem;

  var size = [activeComp.width, activeComp.height];

  acGridsService.setPointControl(masterLayer, acGrids.names.goldenPos1, size*.1, '');
  acGridsService.setPointControl(masterLayer, acGrids.names.goldenPos2, size*.9, '');

  masterLayer.property("ADBE Transform Group").property("ADBE Position").expression = acGrids.expr.goldenPosition;
  masterLayer.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([0,0]);

  var contents = masterLayer.property("ADBE Root Vectors Group");
  var g = contents.addProperty("ADBE Vector Group");
  var g1 = g.property("ADBE Vectors Group");

  g.name = gName;

  var g = g1.addProperty("ADBE Vector Group");
  var g2 = g.property("ADBE Vectors Group");

  g.name = acGrids.names.goldenRect;

  var rect = g2.addProperty("ADBE Vector Shape - Rect");
  rect.name = acGrids.names.rect1;
  rect.property("ADBE Vector Rect Size").expression = acGrids.expr.goldenSize;
  g.property("ADBE Vector Transform Group").property("ADBE Vector Anchor").expression = acGrids.expr.goldenAnchor;

  var r = g1.addProperty("ADBE Vector Filter - Repeater");

  r.property("ADBE Vector Repeater Transform").property("ADBE Vector Repeater Position").setValue([0,0]);

  r.property("ADBE Vector Repeater Copies").setValue(10);
  r.property("ADBE Vector Repeater Transform").property("ADBE Vector Repeater Anchor").expression = acGrids.expr.goldenRepAnchor;
  r.property("ADBE Vector Repeater Transform").property("ADBE Vector Repeater Scale").setValue([1,1]*100/1.618);
  r.property("ADBE Vector Repeater Transform").property("ADBE Vector Repeater Rotation").expression = acGrids.expr.goldenRepRotation;

  //g.property("ADBE Vector Transform Group").property("ADBE Vector Scale").expression = acGrids.expr.aspectCorrect;

  acGridsService.setStroke(g1, thick, color);

}

//acGridsService functions to set various parameters

acGrids.setPushBttn = function(_group, _icon, _tip, _callback){
  var bttn = _group.add("group{margins: 0, alignment: ['left', 'center']}").setIcon(_icon).setTip(_tip);
  bttn.preferredSize = [20,20];
  bttn.addEventListener("mousedown", function(k){
    if(k.button == 0){
      this.setState(true);
    }
  });

  bttn.addEventListener("mouseup", function(k){
    if(k.button == 0){
      this.setState(false);
      _callback;
    }
  });

  return(bttn);
}

var acGridsService = {};

acGridsService.setStroke = function(group, thick, color){
  //seting stroke
  group.addProperty("ADBE Vector Graphic - Stroke");
  group.property("ADBE Vector Graphic - Stroke").property("ADBE Vector Stroke Width").setValue(thick);
  group.property("ADBE Vector Graphic - Stroke").property("ADBE Vector Stroke Color").setValue(color);
}

acGridsService.setSlider = function(masterLayer, slName, slValue, slExpression){
  //adding a slider to the master layer
  var sl = masterLayer.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
  sl.name = slName;
  sl.property("ADBE Slider Control-0001").setValue(slValue);
  sl.property("ADBE Slider Control-0001").expression = slExpression;
}

acGridsService.setPointControl = function(masterLayer, slName, slValue, slExpression){
  //adding a slider to the master layer
  var sl = masterLayer.property("ADBE Effect Parade").addProperty("ADBE Point Control");
  sl.name = slName;
  sl.property("ADBE Point Control-0001").setValue(slValue);
  sl.property("ADBE Point Control-0001").expression = slExpression;
}

acGridsService.setChckbx = function(masterLayer, chkName, chkValue, chkExpression){
  //adding a slider to the master layer
  var sl = masterLayer.property("ADBE Effect Parade").addProperty("ADBE Checkbox Control");
  sl.name = chkName;
  sl.property("ADBE Checkbox Control-0001").setValue(chkValue);
  sl.property("ADBE Checkbox Control-0001").expression = chkExpression;
}

acGridsService.setRepeater = function(_name, group, copiesValue, copiesExpr, offsetValue, offsetExpr, posValue, posExpr){
  //setting repeater parameters
  var r = group.addProperty("ADBE Vector Filter - Repeater");
  r.name = _name;
  r.property("ADBE Vector Repeater Copies").expression = copiesExpr;
  r.property("ADBE Vector Repeater Offset").expression = offsetExpr;
  r.property("ADBE Vector Repeater Transform").property("ADBE Vector Repeater Position").expression = posExpr;

  r.property("ADBE Vector Repeater Copies").setValue(copiesValue);
  r.property("ADBE Vector Repeater Offset").setValue(offsetValue);
  r.property("ADBE Vector Repeater Transform").property("ADBE Vector Repeater Position").setValue(posValue);
  }

acGridsService.parseText = function(thisObj, masterWindow, text){
  //function to parse text with splitline character
  //into multiple staticText lines
  var splitText = text.split('\n');
  for(var l =0; l< splitText.length; l++){
    masterWindow.add("staticText", undefined, splitText[l]).setFG(1,1,1);
  }
}

//And here come expressions!
acGrids.exprPrefix = "//This expressions is created by " + acGrids.scriptTitle +" script\n//by Nik Ska\n\n";

acGrids.expr = {
  prefix: acGrids.exprPrefix +"//This expression is created by "+ acGrids.scriptTitle +" script\n//by Nik Ska\n",
  sliderCheck: acGrids.exprPrefix +'if(value<=25) value = 25\nelse value',


  hexSize: acGrids.exprPrefix +'effect('+'"'+ acGrids.names.hexSize +'"'+')("ADBE Slider Control-0001")',
  hexR1Copies: acGrids.exprPrefix +'R = content('+'"'+acGrids.names.hex+'"'+').content(' + '"' + acGrids.names.hex + '"' + ' ).outerRadius;\nr = R*Math.cos(Math.PI/6);\nv = Math.floor(thisComp.height/(2*R))+1;\nMath.floor(thisComp.width/(2*r))+1+v',
  hexR1Offset: acGrids.exprPrefix +'R = content('+'"'+acGrids.names.hex+'"'+').content(' + '"' + acGrids.names.hex + '"' + ' ).outerRadius;\nr = R*Math.cos(Math.PI/6);\nv = Math.floor(thisComp.height/(2*R))*1.4;\nMath.floor(-1*v)',
  hexR1Pos: acGrids.exprPrefix +'r = content('+'"'+acGrids.names.hex+'"'+').content(' + '"' + acGrids.names.hex + '"' + ' ).outerRadius*Math.cos(Math.PI/6)*2;\n[r,0]',
  hexR2Copies: acGrids.exprPrefix +'R = content('+'"'+acGrids.names.hex+'"'+').content(' + '"' + acGrids.names.hex + '"' + ' ).outerRadius;\nr = R*Math.cos(Math.PI/6);\nv = Math.floor(thisComp.height/(R+r/2))+2;\nv',
  hexR2Offset: acGrids.exprPrefix +'Math.ceil(content('+'"'+acGrids.names.hex+'"'+').content(' + '"' + acGrids.names.rep2 + '"' + ').copies/-2)',
  hexR2Pos: acGrids.exprPrefix +'R =content('+'"'+acGrids.names.hex+'"'+').content(' + '"' + acGrids.names.hex + '"' + ' ).outerRadius\na = 2*R*Math.sin(Math.PI/6);\nr = R*Math.cos(Math.PI/6);\n[r, R+a/2]',


  isoR1Copies: acGrids.exprPrefix +'Math.floor(thisComp.height/effect('+'"'+ acGrids.names.isoSize +'"'+')("ADBE Slider Control-0001"))*2+1',
  isoR1Offset: acGrids.exprPrefix +'Math.floor(content('+'"'+ acGrids.names.iso +'"'+').content("Isometric Big").content(' + '"' + acGrids.names.rep1 + '"' + ').copies/-2)+1',
  isoR1Pos: acGrids.exprPrefix +'[0,effect('+'"'+ acGrids.names.isoSize +'"'+')("ADBE Slider Control-0001")]',

  isoR2Copies: acGrids.exprPrefix +'effect('+'"'+ acGrids.names.isoChck2 +'"'+')("ADBE Checkbox Control-0001")*Math.floor(5*thisComp.height/effect('+'"'+ acGrids.names.isoSize +'"'+')("ADBE Slider Control-0001"))*2',
  isoR2Offset: acGrids.exprPrefix +'Math.floor(content('+'"'+ acGrids.names.iso +'"'+').content('+'"'+ acGrids.names.isoChck2 +'"'+').content(' + '"' + acGrids.names.rep1 + '"' + ').copies/-2)+1',
  isoR2Pos: acGrids.exprPrefix +'[0,effect('+'"'+ acGrids.names.isoSize +'"'+')("ADBE Slider Control-0001")/5]',

  isoR3Copies: acGrids.exprPrefix +'effect('+'"'+ acGrids.names.isoChck1 +'"'+')("ADBE Checkbox Control-0001")*Math.floor(thisComp.height/effect('+'"'+ acGrids.names.isoSize +'"'+')("ADBE Slider Control-0001"))*2+1',
  isoR3Offset: acGrids.exprPrefix +'Math.floor(content('+'"'+ acGrids.names.iso +'"'+').content('+'"'+ acGrids.names.isoChck1 +'"'+').content(' + '"' + acGrids.names.rep1 + '"' + ').copies/-2)+1',
  isoR3Pos: acGrids.exprPrefix +'[effect('+'"'+ acGrids.names.isoSize +'"'+')("ADBE Slider Control-0001")*thisComp.pixelAspect, 0]',
  isoR3PosNew: acGrids.exprPrefix +'[effect('+'"'+ acGrids.names.isoSize +'"'+')("ADBE Slider Control-0001")*thisComp.pixelAspect/(2*Math.tan(Math.PI/6)), 0]',
  isoDash: acGrids.exprPrefix + 'effect('+'"'+ acGrids.names.isoSize +'"'+')("ADBE Slider Control-0001")/40',

  isoVertToggle: acGrids.exprPrefix + 'effect('+'"'+ acGrids.names.isoChck1 +'"'+')("ADBE Checkbox Control-0001")*100',
  isoSmallToggle: acGrids.exprPrefix + 'effect('+'"'+ acGrids.names.isoChck2 +'"'+')("ADBE Checkbox Control-0001")*100',

  sqSize: acGrids.exprPrefix + '[thisComp.pixelAspect,1]*effect('+'"'+ acGrids.names.sqSize +'"'+')("ADBE Slider Control-0001")',
  sqR1Copies: acGrids.exprPrefix + 'Math.floor(thisComp.width/effect('+'"'+ acGrids.names.sqSize +'"'+')("ADBE Slider Control-0001"))+2',
  sqR1Offset: acGrids.exprPrefix + '-Math.floor(content('+'"'+ acGrids.names.sqGrid +'"'+').content('+'"'+ acGrids.names.sqBig +'"'+').content(' + '"' + acGrids.names.rep1 + '"' + ').copies/2)',
  sqR1Pos: acGrids.exprPrefix + '[effect('+'"'+ acGrids.names.sqSize +'"'+')("ADBE Slider Control-0001")*thisComp.pixelAspect,0]',
  sqR2Copies: acGrids.exprPrefix + 'Math.floor(thisComp.height/effect('+'"'+ acGrids.names.sqSize +'"'+')("ADBE Slider Control-0001"))+2',
  sqR2Offset: acGrids.exprPrefix + '-Math.floor(content('+'"'+ acGrids.names.sqGrid +'"'+').content('+'"'+ acGrids.names.sqBig +'"'+').content(' + '"' + acGrids.names.rep2 + '"' + ').copies/2)',
  sqR2Pos: acGrids.exprPrefix + '[0,effect('+'"'+ acGrids.names.sqSize +'"'+')("ADBE Slider Control-0001")]',

  sqSize2: acGrids.exprPrefix + '[thisComp.pixelAspect,1]*effect('+'"'+ acGrids.names.sqSize +'"'+')("ADBE Slider Control-0001")/4',

  sqR3Copies: acGrids.exprPrefix + 'effect('+'"'+ acGrids.names.sqChck +'"'+')("ADBE Checkbox Control-0001")*4*Math.floor(thisComp.width/effect('+'"'+ acGrids.names.sqSize +'"'+')("ADBE Slider Control-0001"))+4',
  sqR3Offset: acGrids.exprPrefix + '-Math.floor(content('+'"'+ acGrids.names.sqGrid +'"'+').content('+'"'+ acGrids.names.sqSmall +'"'+').content(' + '"' + acGrids.names.rep1 + '"' + ').copies/2)',
  sqR3Pos: acGrids.exprPrefix + '[effect('+'"'+ acGrids.names.sqSize +'"'+')("ADBE Slider Control-0001")/4*thisComp.pixelAspect,0]',

  sqR4Copies: acGrids.exprPrefix + 'effect('+'"'+ acGrids.names.sqChck +'"'+')("ADBE Checkbox Control-0001")*4*Math.floor(thisComp.height/effect('+'"'+ acGrids.names.sqSize +'"'+')("ADBE Slider Control-0001"))+4',
  sqR4Offset: acGrids.exprPrefix + '-Math.floor(content('+'"'+ acGrids.names.sqGrid +'"'+').content('+'"'+ acGrids.names.sqSmall +'"'+').content(' + '"' + acGrids.names.rep2 + '"' + ').copies/2)',
  sqR4Pos: acGrids.exprPrefix+ '[0,effect('+'"'+ acGrids.names.sqSize +'"'+')("ADBE Slider Control-0001")/4]',

  sqSmPos: acGrids.exprPrefix + '[thisComp.width*thisComp.pixelAspect, thisComp.height]/2+[1,1]*effect('+'"'+ acGrids.names.sqSize +'"'+')("ADBE Slider Control-0001")/8',
  sqSmallToggle: acGrids.exprPrefix + 'effect('+'"'+ acGrids.names.sqChck +'"'+')("ADBE Checkbox Control-0001")*100',


  safeRect2: acGrids.exprPrefix + 'var s = content('+'"'+ acGrids.names.safe +'"'+').content(' + '"' + acGrids.names.rect1 + '"' + ' ).size;\nvar x = effect('+'"'+ acGrids.names.safeSize +'"'+')("ADBE Slider Control-0001")/100;\n\na2 = (s[0]-s[1]+Math.sqrt(Math.pow((s[0]-s[1]),2)+4*s[0]*s[1]*x));\nb2 = (s[1]-s[0]+Math.sqrt(Math.pow((s[0]-s[1]),2)+4*s[0]*s[1]*x));\n\n.5*[a2,b2]',
  safeSlider: acGrids.exprPrefix + 'if(value<=0) 1;\nelse if(value>=100) 99;\nelse value',

  goldenSize: acGrids.exprPrefix + 'var p2 = effect('+'"'+ acGrids.names.goldenPos2 +'"'+')("ADBE Point Control-0001");\nvar p1 = effect('+'"'+ acGrids.names.goldenPos1 +'"'+')("ADBE Point Control-0001");\n\nvar w1 = Math.abs(p2[0] - p1[0]);\nvar h1 = w1/1.618;\n\n[w1, h1]',
  goldenAnchor: acGrids.exprPrefix + 'var s = content('+'"'+ acGrids.names.golden +'"'+').content('+'"'+ acGrids.names.goldenRect +'"'+').content(' + '"' + acGrids.names.rect1 + '"' + ' ).size\n\nvar p1 = effect('+'"'+ acGrids.names.goldenPos1 +'"'+')("ADBE Point Control-0001");\nvar p2 = effect('+'"'+ acGrids.names.goldenPos2 +'"'+')("ADBE Point Control-0001");\n\nif(p1[0]<p2[0]){\n\tif(p1[1]<p2[1]){\n\t\td1 = -2;\n\t\td2 = -2;\n\t}\n\telse{\n\t\td1 = -2;\n\t\td2 = 2;\n\t}\n}\nelse{\n\tif(p1[1]<p2[1]){\n\t\td1 = 2;\n\t\td2 = -2;\n\t}\n\telse{\n\t\td1 = 2;\n\t\td2 = 2;\n\t}\n}\n\n[s[0]/d1, s[1]/d2]',
  goldenRepAnchor: acGrids.exprPrefix + 'var p1 = effect('+'"'+ acGrids.names.goldenPos1 +'"'+')("ADBE Point Control-0001");\nvar p2 = effect('+'"'+ acGrids.names.goldenPos2 +'"'+')("ADBE Point Control-0001");\n\nvar s = content('+'"'+ acGrids.names.golden +'"'+').content('+'"'+ acGrids.names.goldenRect +'"'+').content(' + '"' + acGrids.names.rect1 + '"' + ' ).size;\nvar ap = content('+'"'+ acGrids.names.golden +'"'+').content('+'"'+ acGrids.names.goldenRect +'"'+').transform.anchorPoint;\n\nif(p1[0]<p2[0]){\n\tif(p1[1]<p2[1]){\n\t\t(s+ap)/1.81\n\t}\n\telse{\n\t\t-ap/1.81\n\t}\n}\nelse{\n\tif(p1[1]<p2[1]){\n\t\t-ap/1.81\n\t}\n\telse{\n\t\t(-s+ap)/1.81\n\t}\n}\n',
  goldenRepRotation: acGrids.exprPrefix + 'var p1 = effect('+'"'+ acGrids.names.goldenPos1 +'"'+')("ADBE Point Control-0001");\nvar p2 = effect('+'"'+ acGrids.names.goldenPos2 +'"'+')("ADBE Point Control-0001");\n\nif(p1[0]<p2[0]){\n\tif(p1[1]<p2[1]){\n\t\t90\n\t}\n\telse{\n\t\t-90\n\t}\n}\nelse{\n\tif(p1[1]<p2[1]){\n\t\t-90\n\t}\n\telse{\n\t\t90\n\t}\n}\n',
  goldenPosition: acGrids.exprPrefix + 'effect('+'"'+ acGrids.names.goldenPos1 +'"'+')("ADBE Point Control-0001")',

  aspectCorrect: acGrids.exprPrefix + '[value[0]*thisComp.pixelAspect, value[1]]',
};

//------------------
//Get-set properties
//------------------

acGrids.setPrefs = function(){
  //save variables' states
  app.settings.saveSetting("acGridsUI", "lastSel", this.lastSel);
};

acGrids.getPrefs = function(){
    //retrieve
    if(app.settings.haveSetting("acGridsUI", "lastSel") === false) this.lastSel = 0;
    else this.lastSel = app.settings.getSetting("acGridsUI", "lastSel");
};

//----------------------
//Prototypes' extensions
//----------------------

Object.prototype.setFG = function(colorArray) {
    if (typeof colorArray != 'undefined' && colorArray.length >=3) {
        this.graphics.foregroundColor = this.graphics.newPen(this.graphics.PenType.SOLID_COLOR, colorArray, 1);
    }
    return this;
};

Object.prototype.setBG = function (colorArray) {
    if (typeof colorArray != 'undefined' && colorArray.length >=3) {
        this.graphics.backgroundColor = this.graphics.newBrush(this.graphics.BrushType.SOLID_COLOR, colorArray);
    }
    return this;
};

Group.prototype.setIcon = function(iconFile) {
    if(iconFile){
        this.icon = this.add("image", undefined, iconFile);
    }
    return this;
};

Object.prototype.setTip = function(hlpTip) {
    if(hlpTip){
        if(this.icon) this.icon.helpTip = hlpTip;
        else this.helpTip = hlpTip;
    }
    return this;
};

Group.prototype.setState = function(state){
    if(state){
        this.state = state;
    }
    else this.state = false;
    this.setBG([[0.25,0.25,0.25], [1, 0.58, 0.0]][Number(this.state)]);
};

Group.prototype.initButton = function(bNum, bName, bState){
  //initializing button
    this.bNum = bNum;
    if(bName){
      this.bName = bName;
      this.setTip(bName);
    }
    this.setState(bState);

    return this;
};

acGrids.buildGUI(acGrids)